<!DOCTYPE html> 
<html>
	<head>
		<title>JsEOQ Resource Loading Demo</title>
		<script src="../eoq2/query/query.js"></script>
		<script src="../eoq2/command/command.js"></script>
		<script src="../eoq2/eoq2.js"></script>
		<script src="../eoq2/util/logger.js"></script>
		<script src="../eoq2/command/result.js"></script>
		<script src="../eoq2/frame/frame.js"></script>
		<script src="../eoq2/event/event.js"></script>
		<script src="../eoq2/domain/domain.js"></script>
		<script src="../eoq2/serialization/serializer.js"></script>
		<script src="../eoq2/serialization/jsonserializer.js"></script>
		<script src="../eoq2/serialization/textserializer.js"></script>
		<script src="../eoq2/domain/remote/websocketdomain.js"></script>
		
		<script src="contrib/jquery/jquery-3.3.1.min.js"></script>

		<link rel="stylesheet" type="text/css" href="css/jseoqdemo.css" />
	</head> 
	<body>
		<h1>EOQ Tester</h1>
		
		<div id="console" class="">
			<!-- all output goes here -->
		</div>

		
		
		<script>

		// Test Area
		/*console.log("TEST AREA START ########");
		let testQry = QRY.Qry(null);
		console.log(testQry);

		console.log("TEST AREA STOP ########");*/

		//define serializers globally
		var serializer = new eoq2.serialization.TextSerializer();

		//define test cmds
		test_codes = [
			"GET (!Device{(/path/name=CPM)})",
			// cmd with multiple args
			"SET #34 name untitled",
			// qry without cmd
			"/resources{/name='MinimalFlightControl.oaam'}",
			// extra
			"!Task{(/type/name='Elevator'-(/outputs@SIZE~1))}",
			// multi qry args
			"GET !Task.0@(ASSOCIATES,(/allocations))@CLASSNAME",
			// faulty cmd, unfinished query
			"((/test",
			// faulty cmd, wrong stopping symbol
			"!Device{(/path}}",
			// multi line cmp command
			"GET !Device{(/path/name=CPM)}; SET #1 name test;",
			// test alternative coding
			"GET &CLSDevice&IDX0&PTHname",
			// Test Float Conversion
			"ADD !Device temp -1.234"
		];

		serializer._debugMode=false;

		// run test
		let result;
		for (let idx in test_codes){
			tc = test_codes[idx];
			console.log("\nTesting code "+idx.toString()+" : "+tc);
			try {
				result = serializer.Des(tc);
				console.log("Converting back " + serializer.Ser(result));
				console.log("~~~")
				console.log(result);
				try{
					console.log(result[0].cmd);
					console.log(result[0].a);
				}catch{

				}
				console.log("Success!");
			}catch (e){
				console.log(e);
				console.log("Failed!")
			}
		}

		</script>
	</body>
</html>